diff --git a/ldap/admin/src/scripts/ldif2db.pl.in b/ldap/admin/src/scripts/ldif2db.pl.in
index 379a264..5aff2bb 100644
--- a/ldap/admin/src/scripts/ldif2db.pl.in
+++ b/ldap/admin/src/scripts/ldif2db.pl.in
@@ -108,8 +108,6 @@ $excli = 0;
 $encrypt_on_import = 0;
 $host = "";
 $port = "";
-$first = "yes";
-$prefix = DSUtil::get_prefix();
 
 while ($i <= $#ARGV) {
 	if ( "$ARGV[$i]" eq "-i" ) {	# ldiffiles
@@ -169,68 +167,16 @@ while ($i <= $#ARGV) {
 	}
 	$i++;
 }
+$servid = DSUtil::get_server_id($servid, "@initconfigdir@");
+@info = DSUtil::get_missing_info("@instconfigdir@", $servid, $host, $port, $rootdn);
+$passwd = DSUtil::get_password_from_file($passwd, $passwdfile);
 
-opendir(DIR, "$prefix/etc/sysconfig");
-@files = readdir(DIR);
-foreach $file (@files){
-    if($file =~ /^dirsrv-/ && $file ne "dirsrv-admin"){
-        $instance_count++;
-        if($file =~ /dirsrv-(.*)/){
-            if($first eq "yes"){
-                $instances=$1;
-                $first = "no";
-            } else {
-                $instances=$instances . ", $1";
-            }
-            $name = $1;
-        }
-    }
-}
-    
-if($servid eq ""){
-    if ($instance_count == 1){
-        $servid = $name;
-    } else {
-        &usage;
-        print (STDERR "You must supply a server instance identifier.  Use -Z to specify instance name\n");
-        print "Available instances: $instances\n";
-        exit (1);
-    }
-} elsif ($servid =~ /^dirsrv-/){
-    # strip off "dirsrv-"
-    $servid =~ s/^dirsrv-//;
-} elsif ($servid =~ /^slapd-/){
-    # strip off "slapd-"
-    $servid =~ s/^slapd-//;
-}
-@info = DSUtil::get_missing_info($prefix, $servid, $instances, $host, $port, $rootdn);
-
-if ($passwdfile ne ""){
-# Open file and get the password
-	unless (open (RPASS, $passwdfile)) {
-		die "Error, cannot open password file $passwdfile\n";
-	}
-	$passwd = <RPASS>;
-	chomp($passwd);
-	close(RPASS);
-} elsif ($passwd eq "-"){
-# Read the password from terminal
-	print "Bind Password: ";
-	# Disable console echo
-	system("@sttyexec@ -echo") if -t STDIN;
-	# read the answer
-	$passwd = <STDIN>;
-	# Enable console echo
-	system("@sttyexec@ echo") if -t STDIN;
-	print "\n";
-	chop($passwd); # trim trailing newline
-}
 if (($instance eq "" && $included[0] eq "") || $ldiffiles[0] eq "" || $info[2] eq "" || $passwd eq "") { &usage; exit(1); }
 ($s, $m, $h, $dy, $mn, $yr, $wdy, $ydy, $r) = localtime(time);
 $mn++; $yr += 1900;
 $taskname = "import_${yr}_${mn}_${dy}_${h}_${m}_${s}";
 $dn = "dn: cn=$taskname, cn=import, cn=tasks, cn=config\n";
-$misc = "changetype: add\nobjectclass: top\nobjectclass: extensibleObject\n";
+$misc = "objectclass: top\nobjectclass: extensibleObject\n";
 $cn =  "cn: $taskname\n";
 if ($instance ne "") {
 	$nsinstance = "nsInstance: ${instance}\n";
@@ -264,12 +210,11 @@ if ($uniqidname ne "") { $nsuniqidname = "nsUniqueIdGeneratorNamespace: ${uniqid
 $entry = "${dn}${misc}${cn}${nsinstance}${nsincluded}${nsexcluded}${nsldiffiles}${nsnoattrindexes}${nsimportencrypt}${nsmergechunksiz}${nsgenuniqid}${nsuniqidname}";
 $vstr = "";
 if ($verbose != 0) { $vstr = "-v"; }
-$ENV{'PATH'} = "$prefix@ldaptool_bindir@:$prefix/usr/bin:@ldaptool_bindir@:/usr/bin";
+$ENV{'PATH'} = "@ldaptool_bindir@:/usr/bin:@ldaptool_bindir@:/usr/bin";
 
-DSUtil::libpath_add("$prefix@nss_libdir@");
-DSUtil::libpath_add("$prefix/usr/lib");
 DSUtil::libpath_add("@nss_libdir@");
 DSUtil::libpath_add("/usr/lib");
+DSUtil::libpath_add("/usr/lib64");
 
 $ENV{'SHLIB_PATH'} = "$ENV{'LD_LIBRARY_PATH'}";
 open(FOO, "| ldapmodify @ldaptool_opts@ $vstr -h $info[0] -p $info[1] -D \"$info[2]\" -w \"$passwd\" -a" );
diff --git a/ldap/admin/src/scripts/ldif2ldap.in b/ldap/admin/src/scripts/ldif2ldap.in
index abfb5f4..069470c 100755
--- a/ldap/admin/src/scripts/ldif2ldap.in
+++ b/ldap/admin/src/scripts/ldif2ldap.in
@@ -1,37 +1,22 @@
 #!/bin/sh
 
-libpath_add() {
-    [ -z "$1" ] && return
-    LD_LIBRARY_PATH=${LD_LIBRARY_PATH:+$LD_LIBRARY_PATH:}$1
-}
+source ./DSSharedLib
 
-server_dir="@libdir@/dirsrv/"
-SCRIPT=$(readlink -f $0)
-SCRIPTPATH=$(dirname $SCRIPT)
-if [ $SCRIPTPATH == "/usr/sbin" ]
-then
-    prefix=`echo "$SCRIPTPATH" | sed -e 's/\/usr\/sbin//'`
-    server_sbin="/usr/sbin"
-else
-    prefix=`echo "$SCRIPTPATH" | sed -e 's/\/sbin//'`
-    server_sbin=$prefix"/sbin"
-fi
-
-libpath_add "$prefix@ldapsdk_libdir@"
 libpath_add "@ldapsdk_libdir@"
-libpath_add "$prefix@nss_libdir@"
-libpath_add "$prefix@libdir@"
+libpath_add "@libdir@"
 libpath_add "@nss_libdir@"
-libpath_add "$server_dir"
+libpath_add "@libdir@/dirsrv/"
 
 export LD_LIBRARY_PATH
 SHLIB_PATH=$LD_LIBRARY_PATH
 export SHLIB_PATH
+PATH=$PATH:@ldaptool_bindir@:@ldaptool_bindir@
 
-PATH=$PATH:$prefix@ldaptool_bindir@:@ldaptool_bindir@
+usage ()
+{
+    echo "Usage: ldif2ldap [-Z serverID] -D <bind dn> -w <password> -f <file>"
+}
 
-first="yes"
-args=""
 while getopts "Z:D:w:f:h" flag
 do
     case $flag in
@@ -42,65 +27,29 @@ do
            passwd=$OPTARG;;
         f) args=$args" -f $OPTARG"
            input_file=$OPTARG;;
-        h) echo "Usage: ldif2ldap [-Z serverID] -D <bind dn> -w <password> -f <file>"
+        h) usage
            exit 0;;
-        ?) echo "Usage: ldif2ldap [-Z serverID] -D <bind dn> -w <password> -f <file>"
+        ?) usage
            exit 1;;
     esac
 done
 
 if [ "$binddn" == "" ] || [ "$passwd" == "" ] || [ "$input_file" == "" ]
 then 
-    echo "Usage: ldif2ldap -D <bind dn> -w <password> -f <file>"
+    usage
     exit 1
 fi
 
-# server id not provided, check if there is only one instance
-inst_count=0
-for i in `ls $prefix/etc/sysconfig/dirsrv-* 2>/dev/null`
-do
-    if [ $i != '$prefix/etc/sysconfig/dirsrv-admin' ]
-    then
-        inst_count=`expr $inst_count + 1`
-        id=$(expr "$i" : ".*dirsrv-\([^)]*\).*")
-        if  [ $first == "yes" ]
-        then
-            instances=$id
-            first="no"
-        else
-            instances=$instances", $id"
-        fi
-        name=$id
-    fi
-done 
-    
-if [ -z $servid ]
-then
-    if [ $inst_count -eq 1 ]
-    then
-        servid=$name
-    else 
-        # error
-        echo "Usage: ldif2ldap [-Z serverID] -D <bind dn> -w <password> -f <file>"
-        echo "You must supply a server instance identifier.  Use -Z to specify instance name"
-        echo "Available instances: $instances"
-        exit 1
-    fi
-elif [ $servid == slapd-* ]
-then
-    servid=`echo "$servid" | sed -e 's/slapd-//'`
-elif [ $servid == dirsrv-* ]
-then
-    servid=`echo "$servid" | sed -e 's/dirsrv-//'`
-fi
-if ! [ -a "$prefix/etc/dirsrv/slapd-$servid/dse.ldif" ]
+servid=$(get_server_id "@initconfigdir@" $servid)
+if [ $? == 1 ]
 then
-    echo "Invalid server identifier: $servid"
-    echo "Available instances: $instances"
+    usage
+    echo "You must supply a valid server instance identifier.  Use -Z to specify instance name"
+    echo "Available instances: $servid"
     exit 1
 fi
 
-port=$(grep 'nsslapd-port' $prefix/etc/dirsrv/slapd-$servid/dse.ldif | awk '{print $2}' )
-host=$(grep 'nsslapd-localhost' $prefix/etc/dirsrv/slapd-$servid/dse.ldif | awk '{print $2}' )
+port=$(grep 'nsslapd-port' @instconfigdir@/slapd-$servid/dse.ldif | awk '{print $2}' )
+host=$(grep 'nsslapd-localhost' @instconfigdir@/slapd-$servid/dse.ldif | awk '{print $2}' )
 
 ldapmodify @ldaptool_opts@ -a -p $port -h $host $args
diff --git a/ldap/admin/src/scripts/monitor.in b/ldap/admin/src/scripts/monitor.in
index 6438331..fc3723b 100755
--- a/ldap/admin/src/scripts/monitor.in
+++ b/ldap/admin/src/scripts/monitor.in
@@ -1,94 +1,45 @@
 #!/bin/sh
 
-libpath_add() {
-    [ -z "$1" ] && return
-    LD_LIBRARY_PATH=${LD_LIBRARY_PATH:+$LD_LIBRARY_PATH:}$1
-}
-
-server_dir="@libdir@/dirsrv/"
-SCRIPT=$(readlink -f $0)
-SCRIPTPATH=$(dirname $SCRIPT)
-if [ $SCRIPTPATH == "/usr/sbin" ]
-then
-    prefix=`echo "$SCRIPTPATH" | sed -e 's/\/usr\/sbin//'`
-else
-    prefix=`echo "$SCRIPTPATH" | sed -e 's/\/sbin//'`
-fi
+source ./DSSharedLib
 
-libpath_add "$server_dir"
-libpath_add "$prefix@ldapsdk_libdir@"
+libpath_add "@libdir@/dirsrv/"
 libpath_add "@ldapsdk_libdir@"
-libpath_add "$prefix@nss_libdir@"
-libpath_add "$prefix@libdir@"
+libpath_add "@libdir@"
 libpath_add "@nss_libdir@"
 
 export LD_LIBRARY_PATH
 SHLIB_PATH=$LD_LIBRARY_PATH
 export SHLIB_PATH
+PATH=$PATH:@ldaptool_bindir@:@ldaptool_bindir@
 
-PATH=$PATH:$prefix@ldaptool_bindir@:@ldaptool_bindir@
+usage ()
+{
+    echo "Usage: monitor [ -Z serverID ] [ -b basedn ]"
+}
 
 while getopts "Z:b:h" flag
 do
     case $flag in
         Z) servid=$OPTARG;;
         b) MDN=$OPTARG;;
-        h) echo "Usage: monitor [ -Z serverID ] [ -b basedn ]"
+        h) usage
            exit 0;;
-        ?) echo "Usage: monitor [ -Z serverID ] [ -b basedn ]"
+        ?) usage
            exit 1;;
     esac
 done
 
-first="yes"
-
-# server id not provided, check if there is only one instance
-inst_count=0
-for i in `ls $prefix/etc/sysconfig/dirsrv-* 2>/dev/null`
-do
-    if [ $i != '$prefix/etc/sysconfig/dirsrv-admin' ]
-    then
-        inst_count=`expr $inst_count + 1`
-        id=$(expr "$i" : ".*dirsrv-\([^)]*\).*")
-        if  [ $first == "yes" ]
-        then
-            instances=$id
-            first="no"
-        else
-            instances=$instances", $id"
-        fi
-        name=$id
-    fi
-done 
-    
-if [ -z $servid ]
-then
-    if [ $inst_count -eq 1 ]
-    then
-        servid=$name
-    else 
-        # error
-        echo "Usage: monitor [ -Z serverID ] [ -b basedn ]"
-        echo "You must supply a server instance identifier.  Use -Z to specify instance name"
-        echo "Available instances: $instances"
-        exit 1
-    fi
-elif [ $servid == slapd-* ]
-then
-    servid=`echo "$servid" | sed -e 's/slapd-//'`
-elif [ $servid == dirsrv-* ]
-then
-    servid=`echo "$servid" | sed -e 's/dirsrv-//'`
-fi
-if ! [ -a "$prefix/etc/dirsrv/slapd-$servid/dse.ldif" ]
+servid=$(get_server_id "@initconfigdir@" $servid)
+if [ $? == 1 ]
 then
-    echo "Invalid server identifier: $servid"
-    echo "Available instances: $instances"
+    usage
+    echo "You must supply a valid server instance identifier.  Use -Z to specify instance name"
+    echo "Available instances: $servid"
     exit 1
 fi
 
-port=$(grep 'nsslapd-port' $prefix/etc/dirsrv/slapd-$servid/dse.ldif | awk '{print $2}' )
-host=$(grep 'nsslapd-localhost' $prefix/etc/dirsrv/slapd-$servid/dse.ldif | awk '{print $2}' )
+port=$(grep 'nsslapd-port' @instconfigdir@/slapd-$servid/dse.ldif | awk '{print $2}' )
+host=$(grep 'nsslapd-localhost' @instconfigdir@/slapd-$servid/dse.ldif | awk '{print $2}' )
 
 if [ -z $MDN ]
 then
diff --git a/ldap/admin/src/scripts/ns-accountstatus.pl.in b/ldap/admin/src/scripts/ns-accountstatus.pl.in
index eac9473..ee56914 100644
--- a/ldap/admin/src/scripts/ns-accountstatus.pl.in
+++ b/ldap/admin/src/scripts/ns-accountstatus.pl.in
@@ -42,8 +42,6 @@
 use lib qw(@perlpath@);
 use DSUtil;
 
-$prefix = DSUtil::get_prefix();
-
 ###############################
 # SUB-ROUTINES
 ###############################
@@ -391,9 +389,9 @@ else
 }
 
 debug("Running ** $cmd ** $operation\n");
-$ENV{'PATH'} = "$prefix@ldaptool_bindir@:$prefix/usr/bin:@ldaptool_bindir@:/usr/bin";
-DSUtil::libpath_add("$prefix@nss_libdir@");
-DSUtil::libpath_add("$prefix/usr/lib");
+$ENV{'PATH'} = "@ldaptool_bindir@:/usr/bin:@ldaptool_bindir@:/usr/bin";
+DSUtil::libpath_add("@nss_libdir@");
+DSUtil::libpath_add("/usr/lib");
 DSUtil::libpath_add("@nss_libdir@");
 DSUtil::libpath_add("/usr/lib");
 
@@ -411,7 +409,6 @@ $pwfile = "";
 $entry = "";
 $single = 0;
 $role = 0;
-$first = "yes";
 
 # Process the command line arguments
 while( $arg = shift)
@@ -457,61 +454,9 @@ while( $arg = shift)
 	}
 }
 
-opendir(DIR, "$prefix/etc/sysconfig");
-@files = readdir(DIR);
-foreach $file (@files){
-    if($file =~ /^dirsrv-/ && $file ne "dirsrv-admin"){
-        $instance_count++;
-        if($file =~ /dirsrv-(.*)/){
-            if($first eq "yes"){
-                $instances=$1;
-                $first = "no";
-            } else {
-                $instances=$instances . ", $1";
-            }
-            $name = $1;
-        }
-    }
-}
-
-if($servid eq ""){
-    if ($instance_count == 1){
-        $servid = $name;
-    } else {
-        &usage;
-        print "You must supply a server instance identifier.  Use -Z to specify instance name\n";
-        print "Available instances: $instances\n";
-        exit (1);
-    }
-} elsif ($servid =~ /^dirsrv-/){
-    # strip off "dirsrv-"
-    $servid =~ s/^dirsrv-//;
-} elsif ($servid =~ /^slapd-/){
-    # strip off "slapd-"
-    $servid =~ s/^slapd-//;
-}
-@info = DSUtil::get_missing_info($prefix, $servid, $instances, $host, $port, $rootdn);
-
-if ($pwfile ne ""){
-# Open file and get the password
-	unless (open (RPASS, $pwfile)) {
-		die "Error, cannot open password file $passwdfile\n";
-	}
-	$rootpw = <RPASS>;
-	chomp($rootpw);
-	close(RPASS);
-} elsif ($rootpw eq "-"){
-# Read the password from terminal
-	print "Bind Password: ";
-	# Disable console echo
-	system("@sttyexec@ -echo") if -t STDIN;
-	# read the answer
-	$rootpw = <STDIN>;
-	# Enable console echo
-	system("@sttyexec@ echo") if -t STDIN;
-	print "\n";
-	chop($rootpw); # trim trailing newline
-}
+$servid = DSUtil::get_server_id($servid, "@initconfigdir@");
+@info = DSUtil::get_missing_info("@instconfigdir@", $servid, $host, $port, $rootdn);
+$rootpw = DSUtil::get_password_from_file($rootpw, $pwfile);
 
 if( $rootpw eq "" || $entry eq "")
 {
diff --git a/ldap/admin/src/scripts/ns-activate.pl.in b/ldap/admin/src/scripts/ns-activate.pl.in
index 3660aa4..f7254e0 100644
--- a/ldap/admin/src/scripts/ns-activate.pl.in
+++ b/ldap/admin/src/scripts/ns-activate.pl.in
@@ -359,7 +359,6 @@ sub checkScope
 ###############################
 
 # Generated variable
-$prefix = DSUtil::get_prefix();
 
 # Determine which command we are running
 if ( $0 =~ /ns-inactivate(.pl)?$/ )
@@ -395,10 +394,10 @@ else
 
 debug("Running ** $cmd ** $operation\n");
 
-$ENV{'PATH'} = "$prefix@ldaptool_bindir@:$prefix/usr/bin:@ldaptool_bindir@:/usr/bin";
+$ENV{'PATH'} = "@ldaptool_bindir@:/usr/bin:@ldaptool_bindir@:/usr/bin";
 
-DSUtil::libpath_add("$prefix@nss_libdir@");
-DSUtil::libpath_add("$prefix/usr/lib");
+DSUtil::libpath_add("@nss_libdir@");
+DSUtil::libpath_add("/usr/lib");
 DSUtil::libpath_add("@nss_libdir@");
 DSUtil::libpath_add("/usr/lib");
 
@@ -414,7 +413,6 @@ $host = "";
 $rootpw = "";
 $pwfile = "";
 $entry = "";
-$first = "yes";
 $single = 0;
 $role = 0;
 
@@ -462,61 +460,9 @@ while( $arg = shift)
 	}
 }
 
-opendir(DIR, "$prefix/etc/sysconfig");
-@files = readdir(DIR);
-foreach $file (@files){
-    if($file =~ /^dirsrv-/ && $file ne "dirsrv-admin"){
-        $instance_count++;
-        if($file =~ /dirsrv-(.*)/){
-            if($first eq "yes"){
-                $instances=$1;
-                $first = "no";
-            } else {
-                $instances=$instances . ", $1";
-            }
-            $name = $1;
-        }
-    }
-}
-    
-if($servid eq ""){
-    if ($instance_count == 1){
-        $servid = $name;
-    } else {
-        &usage;
-        print "You must supply a server instance identifier.  Use -Z to specify instance name\n";
-        print "Available instances: $instances\n";
-        exit (1);
-    }
-} elsif ($servid =~ /^dirsrv-/){
-    # strip off "dirsrv-"
-    $servid =~ s/^dirsrv-//;
-} elsif ($servid =~ /^slapd-/){
-    # strip off "slapd-"
-    $servid =~ s/^slapd-//;
-}
-@info = DSUtil::get_missing_info($prefix, $servid, $instances, $host, $port, $rootdn);
-
-if ($pwfile ne ""){
-# Open file and get the password
-	unless (open (RPASS, $pwfile)) {
-		die "Error, cannot open password file $passwdfile\n";
-	}
-	$rootpw = <RPASS>;
-	chomp($rootpw);
-	close(RPASS);
-} elsif ($rootpw eq "-"){
-# Read the password from terminal
-	print "Bind Password: ";
-	# Disable console echo
-	system("@sttyexec@ -echo") if -t STDIN;
-	# read the answer
-	$rootpw = <STDIN>;
-	# Enable console echo
-	system("@sttyexec@ echo") if -t STDIN;
-	print "\n";
-	chop($rootpw); # trim trailing newline
-}
+$servid = DSUtil::get_server_id($servid, "@initconfigdir@");
+@info = DSUtil::get_missing_info("@instconfigdir@", $servid, $host, $port, $rootdn);
+$rootpw = DSUtil::get_password_from_file($rootpw, $pwfile);
 
 if( $rootpw eq "" || $entry eq "")
 {
diff --git a/ldap/admin/src/scripts/ns-inactivate.pl.in b/ldap/admin/src/scripts/ns-inactivate.pl.in
index 9aa17e1..cf82eea 100644
--- a/ldap/admin/src/scripts/ns-inactivate.pl.in
+++ b/ldap/admin/src/scripts/ns-inactivate.pl.in
@@ -359,7 +359,6 @@ sub checkScope
 ###############################
 
 # Generated variable
-$prefix = DSUtil::get_prefix();
 
 # Determine which command we are running
 if ( $0 =~ /ns-inactivate(.pl)?$/ )
@@ -395,10 +394,10 @@ else
 
 debug("Running ** $cmd ** $operation\n");
 
-$ENV{'PATH'} = "$prefix@ldaptool_bindir@:$prefix/usr/bin:@ldaptool_bindir@:/usr/bin";
+$ENV{'PATH'} = "@ldaptool_bindir@:/usr/bin:@ldaptool_bindir@:/usr/bin";
 
-DSUtil::libpath_add("$prefix@nss_libdir@");
-DSUtil::libpath_add("$prefix/usr/lib");
+DSUtil::libpath_add("@nss_libdir@");
+DSUtil::libpath_add("/usr/lib");
 DSUtil::libpath_add("@nss_libdir@");
 DSUtil::libpath_add("/usr/lib");
 
@@ -414,7 +413,6 @@ $pwfile = "";
 $host = "";
 $port = "";
 $entry = "";
-$first = "yes";
 $single = 0;
 $role = 0;
 
@@ -461,62 +459,9 @@ while( $arg = shift)
 		exit(1);
 	}
 }
-
-opendir(DIR, "$prefix/etc/sysconfig");
-@files = readdir(DIR);
-foreach $file (@files){
-    if($file =~ /^dirsrv-/ && $file ne "dirsrv-admin"){
-        $instance_count++;
-        if($file =~ /dirsrv-(.*)/){
-            if($first eq "yes"){
-                $instances=$1;
-                $first = "no";
-            } else {
-                $instances=$instances . ", $1";
-            }
-            $name = $1;
-        }
-    }
-}
-    
-if($servid eq ""){
-    if ($instance_count == 1){
-        $servid = $name;
-    } else {
-        &usage;
-        print "You must supply a server instance identifier.  Use -Z to specify instance name\n";
-        print "Available instances: $instances\n";
-        exit (1);
-    }
-} elsif ($servid =~ /^dirsrv-/){
-    # strip off "dirsrv-"
-    $servid =~ s/^dirsrv-//;
-} elsif ($servid =~ /^slapd-/){
-    # strip off "slapd-"
-    $servid =~ s/^slapd-//;
-}
-@info = DSUtil::get_missing_info($prefix, $servid, $instances, $host, $port, $rootdn);
-
-if ($pwfile ne ""){
-# Open file and get the password
-	unless (open (RPASS, $pwfile)) {
-		die "Error, cannot open password file $passwdfile\n";
-	}
-	$rootpw = <RPASS>;
-	chomp($rootpw);
-	close(RPASS);
-} elsif ($rootpw eq "-"){
-# Read the password from terminal
-	print "Bind Password: ";
-	# Disable console echo
-	system("@sttyexec@ -echo") if -t STDIN;
-	# read the answer
-	$rootpw = <STDIN>;
-	# Enable console echo
-	system("@sttyexec@ echo") if -t STDIN;
-	print "\n";
-	chop($rootpw); # trim trailing newline
-}
+$servid = DSUtil::get_server_id($servid, "@initconfigdir@");
+@info = DSUtil::get_missing_info("@instconfigdir@", $servid, $host, $port, $rootdn);
+$rootpw = DSUtil::get_password_from_file($rootpw, $pwfile);
 
 if( $rootpw eq "" || $entry eq "")
 {
diff --git a/ldap/admin/src/scripts/ns-newpwpolicy.pl.in b/ldap/admin/src/scripts/ns-newpwpolicy.pl.in
index 4486ad1..d785147 100755
--- a/ldap/admin/src/scripts/ns-newpwpolicy.pl.in
+++ b/ldap/admin/src/scripts/ns-newpwpolicy.pl.in
@@ -45,13 +45,12 @@ use DSUtil;
 # enable the use of our bundled perldap with our bundled ldapsdk libraries
 # all of this nonsense can be omitted if the mozldapsdk and perldap are
 # installed in the operating system locations (e.g. /usr/lib /usr/lib/perl5)
-$prefix = DSUtil::get_prefix();
-$ENV{'PATH'} = "$prefix@ldaptool_bindir@:$prefix/usr/bin:@ldaptool_bindir@:/usr/bin";
 
-DSUtil::libpath_add("$prefix@nss_libdir@");
-DSUtil::libpath_add("$prefix/usr/lib");
+$ENV{'PATH'} = "@ldaptool_bindir@:/usr/bin:@ldaptool_bindir@:/usr/bin";
+
 DSUtil::libpath_add("@nss_libdir@");
 DSUtil::libpath_add("/usr/lib");
+DSUtil::libpath_add("/usr/lib64");
 
 $ENV{'SHLIB_PATH'} = "$ENV{'LD_LIBRARY_PATH'}";
 # Add new password policy specific entries
@@ -102,41 +101,8 @@ sub usage {
 {
 	usage() if (!getopts('vD:w:j:p:h:U:S:Z:'));
 
-	$first = "yes";
-
-    opendir(DIR, "$prefix/etc/sysconfig");
-    @files = readdir(DIR);
-    foreach $file (@files){
-        if($file =~ /^dirsrv-/ && $file ne "dirsrv-admin"){
-            $instance_count++;
-            if($file =~ /dirsrv-(.*)/){
-                if($first eq "yes"){
-                    $instances=$1;
-                    $first = "no";
-                } else {
-                    $instances=$instances . ", $1";
-                }
-                $name = $1;
-            }
-        }    
-    }
-        
-    if($opt_Z eq ""){
-        if ($instance_count == 1){
-            $opt_Z = $name;
-        } else {
-            print (STDERR "You must supply a server instance identifier.  Use -Z to specify instance name\n");
-            print "Available instances: $instances\n";
-            exit (1);
-        }
-    } elsif ($opt_Z =~ /^dirsrv-/){
-        # strip off "dirsrv-"
-        $opt_Z =~ s/^dirsrv-//;
-    } elsif ($opt_Z =~ /^slapd-/){
-        # strip off "slapd-"
-        $opt_Z =~ s/^slapd-//;
-    }
-    @info = DSUtil::get_missing_info($prefix, $opt_Z, $instances, $opt_h, $opt_p, $opt_D);
+    $opt_Z = DSUtil::get_server_id($opt_Z, "@initconfigdir@");
+    @info = DSUtil::get_missing_info("@instconfigdir@", $opt_Z, $opt_h, $opt_p, $opt_D);
     
 	if ($opt_j ne ""){
 		die "Error, cannot open password file $opt_j\n" unless (open (RPASS, $opt_j));
diff --git a/ldap/admin/src/scripts/restart-slapd.in b/ldap/admin/src/scripts/restart-slapd.in
index 800c512..8712082 100644
--- a/ldap/admin/src/scripts/restart-slapd.in
+++ b/ldap/admin/src/scripts/restart-slapd.in
@@ -1,5 +1,7 @@
 #!/bin/sh
 
+source ./DSSharedLib
+
 # Script that restarts the ns-slapd server.
 # Exit status can be:
 #       0: Server restarted successfully
@@ -7,8 +9,11 @@
 #       2: Server started successfully (was not running)
 #       3: Server could not be stopped
 
-first="yes"
-args=""
+usage ()
+{
+    echo "Usage: restart-slapd [-Z serverID]"
+}
+
 while getopts "Z:SvVhi:d:w:" flag
 do
     case $flag in
@@ -19,70 +24,23 @@ do
         i) args=$args" -i $OPTARG";;
         w) args=$args" -w $OPTARG";;
         S) args=$args" -S";; 
-        h) echo "Usage: restart-slapd [-Z serverID]"
+        h) usage
            exit 0;;
-        ?) echo "Usage: restart-slapd [-Z serverID]"
+        ?) usage
            exit 1;;
     esac
 done
 
-SCRIPT=$(readlink -f $0)
-SCRIPTPATH=$(dirname $SCRIPT)
-if [ $SCRIPTPATH == "/usr/sbin" ]
-then
-    prefix=`echo "$SCRIPTPATH" | sed -e 's/\/usr\/sbin//'`
-else
-    prefix=`echo "$SCRIPTPATH" | sed -e 's/\/sbin//'`
-fi
-
-# server id not provided, check if there is only one instance
-inst_count=0
-for i in `ls $prefix/etc/sysconfig/dirsrv-* 2>/dev/null`
-do
-    if [ $i != '$prefix/etc/sysconfig/dirsrv-admin' ]
-    then
-        inst_count=`expr $inst_count + 1`
-        id=$(expr "$i" : ".*dirsrv-\([^)]*\).*")
-        if  [ $first == "yes" ]
-        then
-            instances=$id
-            first="no"
-        else
-            instances=$instances", $id"
-        fi
-        name=$id
-    fi
-done 
-    
-if [ -z $servid ]
-then
-    if [ $inst_count -eq 1 ]
-    then
-        servid=$name
-    else 
-        # error
-        echo "Usage: restart-slapd [-Z serverID]"
-        echo "You must supply a server instance identifier.  Use -Z to specify instance name"
-        echo "Available instances: $instances"
-        exit 1
-    fi
-elif [ $servid == slapd-* ]
-then
-    servid=`echo "$servid" | sed -e 's/slapd-//'`
-elif [ $servid == dirsrv-* ]
-then
-    servid=`echo "$servid" | sed -e 's/dirsrv-//'`
-fi
-
-
-if ! [ -a "$prefix/etc/dirsrv/slapd-$servid/dse.ldif" ]
+servid=$(get_server_id "@initconfigdir@" $servid)
+if [ $? == 1 ]
 then
-    echo "Invalid server identifier: $servid"
-    echo "Available instances: $instances"
+    usage
+    echo "You must supply a valid server instance identifier.  Use -Z to specify instance name"
+    echo "Available instances: $servid"
     exit 1
 fi
 
-@sbindir@/restart-dirsrv -d $prefix/etc/sysconfig $servid $args
+@sbindir@/restart-dirsrv -d @initconfigdir@ $servid $args
 if [ $? == 0 ]
 then
     echo Sucessfully restarted instance $servid
diff --git a/ldap/admin/src/scripts/restoreconfig.in b/ldap/admin/src/scripts/restoreconfig.in
index 1f5ea8e..c8f68bd 100755
--- a/ldap/admin/src/scripts/restoreconfig.in
+++ b/ldap/admin/src/scripts/restoreconfig.in
@@ -1,101 +1,47 @@
 #!/bin/sh
 
-libpath_add() {
-    [ -z "$1" ] && return
-    LD_LIBRARY_PATH=${LD_LIBRARY_PATH:+$LD_LIBRARY_PATH:}$1
-}
-
-server_dir="@libdir@/dirsrv/"
-SCRIPT=$(readlink -f $0)
-SCRIPTPATH=$(dirname $SCRIPT)
-if [ $SCRIPTPATH == "/usr/sbin" ]
-then
-    prefix=`echo "$SCRIPTPATH" | sed -e 's/\/usr\/sbin//'`
-    server_sbin="/usr/sbin"
-else
-    prefix=`echo "$SCRIPTPATH" | sed -e 's/\/sbin//'`
-    server_sbin=$prefix"/sbin"
-fi
+source ./DSSharedLib
 
-libpath_add "$server_dir"
-libpath_add "$prefix@nss_libdir@"
-libpath_add "$prefix@libdir@"
-libpath_add "@libdir@"
+libpath_add "@libdir@/dirsrv/"
 libpath_add "@nss_libdir@"
-libpath_add "$prefix@pcre_libdir@"
+libpath_add "@libdir@"
+libpath_add "@pcre_libdir@"
 
 export LD_LIBRARY_PATH
 SHLIB_PATH=$LD_LIBRARY_PATH
 export SHLIB_PATH
 
+usage ()
+{
+    echo "Usage: restoreconfig [-Z serverID]"
+    echo "   -Z      - Server instance identifier"
+}
+
 while getopts "Z:h" flag
 do
     case $flag in
         Z) servid=$OPTARG;;
-        h) echo "Usage: restoreconfig [-Z serverID]"
-           echo "   -Z      - Server instance identifier"
+        h) usage
            exit 0;;
-        ?) echo "Usage: restoreconfig [-Z serverID]"
-           echo "   -Z      - Server instance identifier"
+        ?) usage
            exit 1;;
-           
     esac
 done
 
-first="yes"
-
-# server id not provided, check if there is only one instance
-inst_count=0
-for i in `ls $prefix/etc/sysconfig/dirsrv-* 2>/dev/null`
-do
-    if [ $i != '$prefix/etc/sysconfig/dirsrv-admin' ]
-    then
-        inst_count=`expr $inst_count + 1`
-        id=$(expr "$i" : ".*dirsrv-\([^)]*\).*")
-        if  [ $first == "yes" ]
-        then
-            instances=$id
-            first="no"
-        else
-            instances=$instances", $id"
-        fi
-        name=$id
-    fi
-done 
-    
-if [ -z $servid ]
-then
-    if [ $inst_count -eq 1 ]
-    then
-        servid=$name
-    else 
-        # error
-        echo "Usage: restoreconfig [-Z serverID]"
-        echo "You must supply a server instance identifier.  Use -Z to specify instance name"
-        echo "Available instances: $instances"
-        exit 1
-    fi
-elif [ $servid == slapd-* ]
-then
-    servid=`echo "$servid" | sed -e 's/slapd-//'`
-elif [ $servid == dirsrv-* ]
-then
-    servid=`echo "$servid" | sed -e 's/dirsrv-//'`
-fi
-configdir="$prefix/etc/dirsrv/slapd-$servid"
-if ! [ -a $configdir ]
+servid=$(get_server_id "@initconfigdir@" $servid)
+if [ $? == 1 ]
 then
-    echo "Invalid server identifier: $servid"
-    echo "Available instances: $instances"
+    usage
+    echo "You must supply a valid server instance identifier.  Use -Z to specify instance name"
+    echo "Available instances: $servid"
     exit 1
 fi
 
-cd $server_sbin
-conf_ldif=`ls -1t $prefix/var/lib/dirsrv/slapd-$servid/bak/$servid-*.ldif 2>/dev/null | head -1 `
+conf_ldif=`ls -1t @localstatedir@/lib/@PACKAGE_NAME@/slapd-$servid/bak/$servid-*.ldif 2>/dev/null | head -1 `
 if [ -z "$conf_ldif" ]
 then
-    echo No configuration to restore in $prefix/var/lib/dirsrv/slapd-$servid/bak/ ; exit 1
+    echo No configuration to restore in @localstatedir@/lib/@PACKAGE_NAME@/slapd-$servid/bak/ ; exit 1
 fi
 echo Restoring $conf_ldif...
-./ns-slapd ldif2db -D $configdir -i $conf_ldif -n NetscapeRoot 2>&1
+@sbindir@/ns-slapd ldif2db -D $configdir -i $conf_ldif -n NetscapeRoot 2>&1
 exit $?
diff --git a/ldap/admin/src/scripts/saveconfig.in b/ldap/admin/src/scripts/saveconfig.in
index 62aa160..f388a82 100755
--- a/ldap/admin/src/scripts/saveconfig.in
+++ b/ldap/admin/src/scripts/saveconfig.in
@@ -1,98 +1,47 @@
 #!/bin/sh
 
-libpath_add() {
-    [ -z "$1" ] && return
-    LD_LIBRARY_PATH=${LD_LIBRARY_PATH:+$LD_LIBRARY_PATH:}$1
-}
-
-server_dir="@libdir@/dirsrv/"
-SCRIPT=$(readlink -f $0)
-SCRIPTPATH=$(dirname $SCRIPT)
-if [ $SCRIPTPATH == "/usr/sbin" ]
-then
-    prefix=`echo "$SCRIPTPATH" | sed -e 's/\/usr\/sbin//'`
-    server_sbin="/usr/sbin"
-else
-    prefix=`echo "$SCRIPTPATH" | sed -e 's/\/sbin//'`
-    server_sbin=$prefix"/sbin"
-fi
+source ./DSSharedLib
 
-libpath_add "$server_dir"
-libpath_add "$prefix@nss_libdir@"
-libpath_add "$prefix@libdir@"
+libpath_add "@libdir@/dirsrv/"
 libpath_add "@libdir@"
 libpath_add "@nss_libdir@"
-libpath_add "$prefix@pcre_libdir@"
+libpath_add "@pcre_libdir@"
 
 export LD_LIBRARY_PATH
 SHLIB_PATH=$LD_LIBRARY_PATH
 export SHLIB_PATH
 
+usage ()
+{
+    echo "Usage: saveconfig [-Z serverID]"
+    echo "   -Z      - Server instance identifier"
+}
+
 while getopts "Z:h" flag
 do
     case $flag in
         Z) servid=$OPTARG;;
-        h) echo "Usage: saveconfig [-Z serverID]"
-           echo "   -Z      - Server instance identifier"
+        h) usage
            exit 0;;
-        ?) echo "Usage: saveconfig [-Z serverID]"
-           echo "   -Z      - Server instance identifier"
+        ?) usage
            exit 1;;
     esac
 done
 
-first="yes"
-
-# server id not provided, check if there is only one instance
-inst_count=0
-for i in `ls $prefix/etc/sysconfig/dirsrv-* 2>/dev/null`
-do
-    if [ $i != '$prefix/etc/sysconfig/dirsrv-admin' ]
-    then
-        inst_count=`expr $inst_count + 1`
-        id=$(expr "$i" : ".*dirsrv-\([^)]*\).*")
-        if  [ $first == "yes" ]
-        then
-            instances=$id
-            first="no"
-        else
-            instances=$instances", $id"
-        fi
-        name=$id
-    fi
-done 
-    
-if [ -z $servid ]
-then
-    if [ $inst_count -eq 1 ]
-    then
-        servid=$name
-    else 
-        # error
-        echo "Usage: saveconfig [-Z serverID]"
-        echo "You must supply a server instance identifier.  Use -Z to specify instance name"
-        echo "Available instances: $instances"
-        exit 1
-    fi
-elif [ $servid == slapd-* ]
-then
-    servid=`echo "$servid" | sed -e 's/slapd-//'`
-elif [ $servid == dirsrv-* ]
+servid=$(get_server_id "@initconfigdir@" $servid)
+if [ $? == 1 ]
 then
-    servid=`echo "$servid" | sed -e 's/dirsrv-//'`
-fi
-configdir="$prefix/etc/dirsrv/slapd-$servid"
-if ! [ -a $configdir ]
-then
-    echo "Invalid server identifier: $servid"
-    echo "Available instances: $instances"
+    usage
+    echo "You must supply a valid server instance identifier.  Use -Z to specify instance name"
+    echo "Available instances: $servid"
     exit 1
 fi
 
-cd $server_sbin
+configdir="@instconfigdir@/slapd-$servid"
+
 echo saving configuration...
-conf_ldif=$prefix/var/lib/dirsrv/slapd-$servid/bak/$servid-`date +%Y_%m_%d_%H%M%S`.ldif
-./ns-slapd db2ldif -N -D $configdir -s "o=NetscapeRoot" -a $conf_ldif -n NetscapeRoot 2>&1
+conf_ldif=@localstatedir@/lib/@PACKAGE_NAME@/slapd-$servid/bak/$servid-`date +%Y_%m_%d_%H%M%S`.ldif
+@sbindir@/ns-slapd db2ldif -N -D $configdir -s "o=NetscapeRoot" -a $conf_ldif -n NetscapeRoot 2>&1
 if [ "$?" -ge 1 ] 
 then
     echo Error occurred while saving configuration
